<?php

/**
 * causacion_multas actions.
 *
 * @package    canon
 * @subpackage causacion_multas
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class causacion_multasActions extends sfQuery {

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $valor = str_replace(".", "", $request['valor']);
            $valor = explode(",", $valor);
            $valor = $valor[0];
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $fecha_doc = $request['fecha_doc'];
            $id_titulo = $request['id_titulo'];
            $id_concepto_multa = $request['id_concepto_multa'];
            $id_tipo_multa = $request['id_tipo_multa'];
            $genera_recibo = 0;
            if (isset($request['genera_recibo'])) {
                if ($request['genera_recibo'] == "true") {
                    $genera_recibo = 1;
                }
            }
            $usuario = 0;
            if (isset($request['id_username'])) {
                $usuario = $request['id_username'];
            }

            $sql = <<<EOD

                    
ALTER SESSION SET TIME_ZONE = 'AMERICA/BOGOTA'

            
EOD;


            CN_TABLE::executeSQL($sql, true);

            $sql = <<<EOD
            
select ca_causacion_multa_seq.nextval from dual
    
            
EOD;

            $secuencia = CN_TABLE::executeSQL($sql);


            if (count($secuencia) != 0) {
                $secuencia = $secuencia[0]['nextval'];
            } else {
                throw new Exception("Sequence number error");
            }


            $sql = <<<EOD
            
INSERT
INTO CA_CAUSACION_MULTA
  (
    ID_CAUSACION_MULTA,
    VALOR,
    ID_TIPO_DOC,
    NUM_DOC,
    FECHA_DOC,
    ID_CONCEPTO_MULTA,
    ID_TITULO,
    ID_TIPO_MULTA,
    GENERA_RECIBO,
    ID_USUARIO    
  )
  VALUES
  (
    $secuencia,
    $valor,
    $id_tipo_doc,
    '$num_doc',
    to_date('$fecha_doc', 'yyyy-mm-dd'),
    $id_concepto_multa,
    $id_titulo,
    $id_tipo_multa,
    $genera_recibo,
    $usuario                    
  )
    
            
EOD;

            //Insertar nueva causacion multa
            $this->conn->execute($sql);

            //ND 07 - INDEXACION MULTAS RP - 20180228 
            $sql = <<<EOD
            
select 
  cm.id_causacion_multa, cm.VALOR,
  to_char(cm.fecha_doc, 'YYYY-MM-DD') as fecha_doc_multa,
  to_char(cm.fecha_doc, 'DD/MM/YYYY') as fecha_doc_ob,
  cm.num_doc as num_doc_multa,
  cm.ID_DEBITO,
  cm.SEC_DEBITO,
  cm.id_tipo_multa,
  tip.nombre as nombre_tipo_doc,                           
  TIT.COD_TITULO,
  table2.*,
  --CASOS CONCEPTOS
  CASE 
    -- ND 07 - INDEXACION MULTAS RP                   
    when cm.id_tipo_multa = 2 then 'id_producto_ND07'  
    -- ND 62 – MULTAS RP -  VIGENCIA ACTUAL.
    when extract(year from SYSDATE)=extract(year from cm.fecha_doc) then 'id_producto_ND62'
    --ND 71 fecha_doc < '03-06-2012'
    when cm.fecha_doc<to_date('2012-06-03','YYYY-MM-DD') then 'id_producto_ND71'
    --ND 72 fecha_doc >= '03-06-2012'
    else 'id_producto_ND72'
  END as id_producto_param                           
  from ca_causacion_multa cm
  join rmn_titulo tit on cm.id_titulo=tit.id_titulo
  join ca_tipo_doc tip on tip.id_tipo_doc=cm.id_tipo_doc                           
  join (

  select             
  titper.ID_PERSONA,
  titper.NOMBRE,
  titper.PRIMER_APELLIDO,
  titper.SEGUNDO_APELLIDO,
  titper.TELEFONO,
  titper.CELULAR,
  titper.CORREO,
  titper.CORREO_ALT,
  titper.RAZ_SOC,
  titper.NUM_DOC,
  titper.id_titulo,
  titper.id_titulo_persona,
  titper.id_titular
  from rmn_titulo_persona_mv titper join (
    
    SELECT 
    titper.*,
    ROW_NUMBER() OVER (
    PARTITION BY titper.id_titulo
    ORDER BY titper.id_titulo_persona ASC
    ) AS rn
    from rmn_titulo_persona_mv titper
    --mod by harold 22/06/2015 unico rol valido es titular id_rol=26 HARD CODED
    where titper.actual = 1 and titper.id_rol_titulo=26
    
  )tab on titper.id_titulo_persona = tab.id_titulo_persona 
  and titper.id_titular = tab.id_titular and tab.rn = 1
  order by titper.id_titulo_persona 
  
)table2 on cm.id_titulo=table2.id_titulo 
    
where cm.id_causacion_multa = $secuencia and cm.valor = $valor and cm.id_titulo = $id_titulo

order by cm.id_causacion_multa desc
            
EOD;

            //Insertar nueva causacion intereses
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) == 0) {
                throw new Exception("Ocurrio un error");
            }

            //COMMIT DE TODAS LAS TRANSACCIONES
            $this->conn->commit();

            $this->logMessage("[CA_CAUSACION_MULTA-ADD] Registro Exitoso");
            $this->status = 0;
            $this->totalRows = 1;
            $this->startRow = 0;
            $this->endRow = 1;
            $this->list_data = $records;
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();
            $this->logMessage("[CA_CAUSACION_MULTA-ADD] Registro Fallido $e");
            $this->status = 1;
            $this->list_data = array();
        }
    }

    public function executeUpdate(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * variables de filtro
             */
            $id_causacion_multa = $request['id_causacion_multa'];
            $id_debito = $request['id_debito'];
            $sec_debito = $request['sec_debito'];

            $sql = <<<EOD

UPDATE CA_CAUSACION_MULTA
SET id_debito              =$id_debito,
sec_debito                 =$sec_debito                    
WHERE ID_CAUSACION_MULTA = $id_causacion_multa
   
EOD;

            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            $this->status = 0;
            $this->list_data = $request;
            $this->logMessage("[CA_CAUSACION_MULTA-UPDATE] Consulta Update exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "[CA_CAUSACION_MULTA-UPDATE] Error update";
            $this->list_data = array();
            $this->logMessage("[CA_CAUSACION_MULTA-UPDATE] Error: " . $e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
